#ifndef COMPONENT_H_
#define COMPONENT_H_

#include <vector>
using namespace std;

class Component
{
public:
    Component(string name) : name(name) {}
    virtual ~Component() {}

    virtual void print(int level = 0) = 0;
    virtual void add(Component *comp) = 0;

    void indent(int level) const
    {
        while (level-- > 0) cout << "    ";
    }

protected:
    string name;
};

#endif /* COMPONENT_H_ */
