#ifndef GROUP_H_
#define GROUP_H_

#include <iostream>
#include <string>
#include <vector>
#include "Component.h"

class Group : public Component
{
public:
    Group(string name) : Component(name) {}

    void print(int level)
    {
        indent(level);
        cout << name << endl;

        for (Component *child : children) child->print(level + 1);
    }

    void add(Component *child) { children.push_back(child); }

private:
    vector<Component *> children;
};

#endif /* GROUP_H_ */
